DischargeConveyorActiveFix = {
	prerequisitesPresent = function (specializations)
		return SpecializationUtil.hasSpecialization(ConveyorBelt, specializations) and SpecializationUtil.hasSpecialization(Dischargeable, specializations)
	end
}

function DischargeConveyorActiveFix.registerOverwrittenFunctions(vehicleType)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "setDischargeEffectActive", DischargeConveyorActiveFix.setDischargeEffectActive)
end

function DischargeConveyorActiveFix.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", DischargeConveyorActiveFix)
end

function DischargeConveyorActiveFix:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if self.isClient then
		local spec = self.spec_conveyorBelt

		if spec.lastScrollUpdate then
			self:raiseActive()
		end

		for _, dischargeNode in ipairs(self.spec_dischargeable.dischargeNodes) do
			if dischargeNode.stopEffectTime ~= nil and g_time <= dischargeNode.stopEffectTime then
				self:raiseActive()
			end
		end
	end
end

function DischargeConveyorActiveFix:setDischargeEffectActive(superFunc, dischargeNode, isActive, force)
	if not isActive and not force then
		self:raiseActive()
	end

	return superFunc(self, dischargeNode, isActive, force)
end
